﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread.CellType;

namespace _7659_VCenter
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            CTextCellType txt = new CTextCellType();
            txt.Multiline = true;
            txt.WordWrap = true;
            fpSpread1.ActiveSheet.Columns[0].CellType = txt;
            fpSpread1.ActiveSheet.Columns[0].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center;
            fpSpread1.ActiveSheet.Columns[0].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center;
        }
    }

    public class CTextCellType : FarPoint.Win.Spread.CellType.TextCellType
    {
        C1.Win.C1Input.C1TextBox txt = null;

        public CTextCellType()
        {
            txt = new C1.Win.C1Input.C1TextBox();
            txt.VerticalAlign = C1.Win.C1Input.VerticalAlignEnum.Middle;
            txt.TextAlign = HorizontalAlignment.Center;
            txt.Multiline = true;
            txt.WordWrap = true;
            txt.LostFocus += new EventHandler(txt_LostFocus);
        }

        void txt_LostFocus(object sender, EventArgs e)
        {
            C1.Win.C1Input.C1TextBox txt = sender as C1.Win.C1Input.C1TextBox;
            FarPoint.Win.Spread.FpSpread spread = txt.Parent as FarPoint.Win.Spread.FpSpread;
            spread.ActiveSheet.ActiveCell.Value = txt.Text;
        }

        public override Control GetEditorControl(Control parent, FarPoint.Win.Spread.Appearance appearance, float zoomFactor)
        {
            return txt;
        }

        public override object GetEditorValue()
        {
            return txt.Text;
        }

        public override void SetEditorValue(object value)
        {
            txt.Value = value;
        }
    }
}
